package abc.da.ast;

import java.util.List;

import polyglot.ast.Node;
import polyglot.ast.TypeNode;
import polyglot.types.Flags;
import polyglot.types.SemanticException;
import polyglot.util.Position;
import polyglot.visit.TypeChecker;
import abc.aspectj.ast.AspectBody;
import abc.aspectj.ast.AspectDecl_c;
import abc.aspectj.ast.PerClause;
import abc.da.types.DAAspectType;

/**
 * An aspect declaration with possibly dependent advice declerations.
 * Has additional type checks.
 * @author Eric Bodden
 */
public class DAAspectDecl_c extends AspectDecl_c implements DAAspectDecl {

	public DAAspectDecl_c(Position pos, boolean is_privileged, Flags flags,
			String name, TypeNode superClass, List interfaces, PerClause per,
			AspectBody body) {
		super(pos, is_privileged, flags, name, superClass, interfaces, per,
				body);
	}

	/** 
	 * {@inheritDoc}
	 */
	@Override
	public Node typeCheck(TypeChecker tc) throws SemanticException {
		DAAspectType type = (DAAspectType) type();
		//check that no advice name occurs twice
		type.checkDuplicateAdviceNames();
		return super.typeCheck(tc);
	}

}
