package abc.da.types;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import polyglot.ast.Formal;
import polyglot.types.TypeSystem;
import abc.aspectj.ast.AdviceDecl;
import abc.aspectj.types.AJContext;
import abc.aspectj.types.AJContext_c;
import abc.da.ast.AdviceName;

/**
 * @author Eric Bodden
 */
public class DAContext_c extends AJContext_c implements DAContext {

	protected Map<AdviceName,List<Formal>> adviceNametoFormals;
	protected AdviceDecl currentAdviceDecl;
	
	public DAContext_c(TypeSystem ts) {
		super(ts);
		adviceNametoFormals = new HashMap<AdviceName, List<Formal>>();
	}

	/** 
	 * {@inheritDoc}
	 */
	public void addAdviceNameAndFormals(AdviceName adviceName, List<Formal> formals) {
		adviceNametoFormals.put(adviceName,formals);
	}

	/** 
	 * {@inheritDoc}
	 */
	public Map<AdviceName,List<Formal>> currentAdviceNameToFormals() {
		return adviceNametoFormals;
	}
	
    /** 
     * {@inheritDoc}
     */
    public AJContext pushAdviceDecl(AdviceDecl ad) {
        DAContext_c c = (DAContext_c) super.push();
        c.currentAdviceDecl = ad;
        return c;
    }
    
    /** 
     * {@inheritDoc}
     */
    public AdviceDecl currentAdviceDecl() {
    	return currentAdviceDecl;
    }

}
