package abc.da.visit;

import polyglot.ast.Node;
import polyglot.ast.NodeFactory;
import polyglot.frontend.Job;
import polyglot.types.SemanticException;
import polyglot.types.TypeSystem;
import polyglot.visit.ContextVisitor;
import polyglot.visit.NodeVisitor;
import abc.da.ast.AdviceDependency;

/**
 * This checks that the parameters in {@link AdviceDependency}s are used
 * consistently, i.e. that parameters with the same variable name actually
 * have a common ancestor type.
 * 
 * @author Eric Bodden
 */
public class TypeCheckAdviceParams extends ContextVisitor {

	public TypeCheckAdviceParams(Job job, TypeSystem ts, NodeFactory nf) {
		super(job, ts, nf);
	}

	@Override
	protected NodeVisitor enterCall(Node n) throws SemanticException {
		if(n instanceof AdviceDependency) {
			AdviceDependency adviceDependency = (AdviceDependency) n;
			n = adviceDependency.typeCheckAdviceParams(this);
		}
		return super.enterCall(n);
	}

}
