package abc.tm.weaving.aspectinfo;

import java.util.List;
import java.util.Map;

import polyglot.util.Position;

import abc.da.weaving.aspectinfo.AdviceDependency;
import abc.weaving.aspectinfo.Aspect;

/**
 * An advice dependency created for a tracematch.
 * @author Eric Bodden
 */
public class TMAdviceDependency extends AdviceDependency {

	protected final TraceMatch tracematch;

	public TMAdviceDependency(Map<String, List<String>> strongAdviceNameToVars,
			Map<String, List<String>> weakAdviceNameToVars, Aspect container, TraceMatch tracematch, Position pos) {
		super(strongAdviceNameToVars, weakAdviceNameToVars, container, pos);
		this.tracematch = tracematch;
	}
	
	public TraceMatch getTracematch() {
		return tracematch;
	}

}
